	EQU 	0#0
;RST 0
	JMP	one13	; jump usr routine
CL:	LEB		;b into low adr
CLA:	SBA
	LBA
	OUT	10	;display buffer
	RET
;RST 1
TIME:	LCI	147	; wait for 6.67 MS
TL:	DCC
	JFZ	TL
	RET
	HLT		; unused - align
;RST 2
	JMP	one16	; jump usr routine
CC:	LAM
	OUT	10	; display memory
	RET
	HLT		; unused - align
	HLT		; unused - align
;RST 3
	JMP	one21	; jump usr routine
WD2:	RLC
	NDI	360
	ORE	
	LMA		; fall through to do inhl and ret
;RST 4
INHL:	INL		; increment H:L
	RFZ
	INH		; if L=0 then increment H
	RET
CH:	LDB		; put B in high addr
	JMP	CLA
;RST 5
	JMP	one24	; jump to user rst pointer
CDA:	DCE		; continue decrement D:E
	NDA
	RFZ
	DCD
	RET
;RST 6
	JMP 	one27	; jump to user rst pointer
CX:	JMP 	one0	; jump to execute pointer
CV:	JMP 	one32	; jump to extd ctl pointer
; Last word of last JMP (above) is executed by RST 7 as one word
; instruction, which acts as a nop instruciton
;RST 7				
	LAI	377	;initialize TTY output
	OUT	11
	OUT	13
CLP:	CAL	BCIN	; get a word from creed keybd
	LHC		; H= 0
	LHI	\LB\TTBL
	LCI	11	; loop index
CB:	INL
	DCC
	JTZ	CA	; jump if not this digit
	CPM
	JFZ	CB	; jmp if not this digit
	DCC		; correct octal digit
	LAB		; get current data from buffer
	RLC
	RLC		; shift left 3 bits
	RLC
	NDI	370	; clear low 3 bits
	ORC		; or in 3 new bits
	LBA		; put back in buffer
	OUT	10	; display buffer on panel
	JMP	CLP	; go back to main loop
CA:	CAL	CA2	; look for a control character
	CFZ	1005	; execute ctonrol routine if Z=0
	JMP	CLP	; go back to main loop
CA3:	INL		; increment table adr pointer
	INL
	RTZ		; return if end of table
; tabel search routien. start at H:L address
; and go to end of page.  each table entry has
; two words: character and lwo adr. if a is
; found in table Z=0 and jmp to low adr in this
; page is constructed at 1005.  If A is not 
; in tabel then Z =1
CA2:	CPM		;is this an octal digit
	JFZ	CA3
CF:	INL		; control character found
	LCM
	LAH
	LLI	5	; construct JMP instruction at
	LHI	2	; 1005
	LMI	104	; insert JMP op code
	INL
	LMC
	INL
	LMA
	LHD
	LLE
	RET
LOAD:	LLI 	0	; load memory from srial dev
	LHI	2	; set up jump at exec. location
	LMI	104	; insert jump op code
	RST	4	; increment HL
LD1:	CAL	WD	; get low adr from tape
	JTZ	LD1	; skip header
	CAL	WD	; get high adr from tape
	RTZ
	DCL
	DCL
	LLM
	LHA
X:	CAL	WD	; load loop
	RTZ		; stop if blank trailer
	JMP	X
; get two 5 bit words and combine them into
; one 8 bit word
WD:	CAL	RD	; get first 5 bit word
	RTZ
	NDI	17	; mask out all but 4 bits
	LEA
	CAL	RD	; get second 5 bit word
	RTZ
	RLC		; shift second word in order
	RLC		; to combine with first
	RLC		; word
	JMP	WD2	; continue at WD2
; get a 5 bit word from creed
RD:	INP	0
	NDA		; destroys A, B, C
	JTS	RD	; wait for start bit
	LBI	100	; load marker bit
RL:	RST	1	; wait 1/2 bit time
	INP	0
	RST	1	; wait
	NDI	200	; mask out the bit
	ADB		; add A and B and carry = 0
	RAR
	LBA
	JFC	RL	; look for marker bit
	RRC
	LBA
	NDI	37	; mask and check for blank
	RTZ		; return if blank with Z=1
	CPB		; clear Z bit
	RET
CD:	LAE		; decrement D:E
	JMP	CDA	; contineu at CDA
CW:	LMB		; write B at address in memory
	SBA
	LBA
	OUT	10	; display on panel
CI:	INE		; increment address pointer
	RTZ	
	IND		; if E=0 increment D
	RET
BCOT:	ORI	140	; basic creed output
	RAL		; destroys A,C
OUTL:	OUT	11	; put out a serial bit
	RST	1	; wait 1/2 bit time
	RAR
	NDA
	RTZ		; return if finished with word
	RST	1	; wait 1/2 bit time
	JMP	OUTL
BCIN:	INP	0	; basic creed input
	NDI	100	; destroys A,C
	JTZ	BCIN	; wait for strobe bit
	RST	1	; wait 1/2 bit time
	INP	0	; get the 5 parallel bits
	RST	1
	RST	1	; wait for strobe bit to go away
	RRC
	NDI	37	; mask out all but 5 bits
TTBL:	RET
; this table has octal charctets, control
; characters and addres of control subroutine
; note that first tabel entry is also ret
; above, I E overlap is OK
;	DATA	07,	; 7
	DATA	25	; 6
	DATA	20	; 5
	DATA	12	; 4
	DATA	01	; 3
	DATA	23	; 2
	DATA	27	; 1
	DATA	26	; 0
	DATA	22
	DATA	\LB\CL	; put buffer in low adr
	DATA	24	; H
	DATA	\LB\CH	; put buffer in high adr
	DATA	06	; I
	DATA	\LB\CI	; increment adr pointer
	DATA	34	; M
	DATA	\LB\CW	; write buffer in memory
	DATA	35	; X
	DATA	\LB\CX	; execute loaded program
	DATA	30	; O
	DATA	\LB\LOAD; load memory
	DATA	11	; D
	DATA	\LB\CD	; decrement address pointer
	DATA	36	; V
	DATA	\LB\CV	; extended control routine
	DATA	16	; C
	DATA	\LB\CC	; display memory on panel
;ram layout
one0:	EQU	1#0
	JMP	0	; execute last loaded instruction
one3:	EQU	1#3	; end address ofr dump program
one5:	EQU	1#5	; save and monitor execute area
one11:	EQU	1#11	; case bit for ascii conversion
one12:	EQU	1#12	; output port status
one13:	EQU	1#13	
one16:	JMP	0	; RST 0 USER POINTER
	JMP	0	; RST 20 USER POINTER
one21:	JMP	0	; RST 30 USER POINTER
one24:	JMP	0	; RST 50 USER POINTER
one27:	JMP	0	; RST 60 USER POINTER
one32:	LHI 	0	; ) enter here from user command V
	LLI	0	; ) load address of user command table
	CAL	BCIN	; get next character from CREED
	CAl	CA2	; do table search
	JFZ	one5	; execute command if found
	RET		; return to monitor
HDTL:	JMP	0	; go to header or trailer routined
			; or insert ret if none
AOT8:	LAA		; NOP(LAA) if start address is to be
			; punched or insert RET if not
OT8:	JMP	0	; goto subroutien to punch an 8
			; bit word and incrment H:L




